﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Silvermoon.Windows;
using Silvermoon.Windows.Styles;
using Silvermoon.Controls;
using Silvermoon.Shapes;
using System.Drawing;

namespace Calculator
{
    public static class StylePool
    {
        public static readonly StyleDictionary Styles;

        static StylePool()
        {
            Styles = new MetroStyles();
            Styles.SetNamed(new ButtonStyle
            {
                Name = "CalcButton",
                Background = PhoneColors.Black,
                Chrome = new BorderShape { BorderSize = 1, Opacity = 24, Color = PhoneColors.White },
                StateManager = StateManagers.ButtonManager,
                TextColor = PhoneColors.White,
                Font = FontPool.MediumRegularFont
            });

            Styles.SetNamed(new ButtonStyle
            {
                Name = "SmallButton",
                Background = PhoneColors.Black,
                Chrome = new BorderShape { BorderSize = 1, Opacity = 24, Color = PhoneColors.White },
                Color = PhoneColors.Black,
                StateManager = StateManagers.ButtonManager,
                TextColor = PhoneColors.White,
                //                Font = FontPool.MediumRegularFont
            });

            Styles.SetClass<TextBox>(new Style
            {
                Chrome = Shape.Empty,
                Background = PhoneColors.White,
                TextColor = PhoneColors.Black,
                StateManager = new Silvermoon.UI.VisualStateManager()
            });

            Styles.SetClass<MenuItem>(new TextItemStyle { Font = FontPool.MediumRegularFont });
        }
    }
}
