﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Passwords.Biz;

namespace Passwords.DAL
{
    public interface IDalContext : IDisposable
    {
        IEnumerable<Category> GetCategories();

        IEnumerable<Password> GetPasswords();

        IEnumerable<CategoryLabel> GetCategoryLabels();

        IEnumerable<PasswordCategory> GetPasswordCategories();

        IEnumerable<PasswordLabel> GetLabels();

        void UpdatePassword(Password password);

        void DeletePassword(Password password);

        void AddPassword(Password password);

        void AddCategory(Category category);

        void UpdateCategory(Category category);

        void DeleteCategory(Category category);

        void UpdateLabel(PasswordLabel label);

        void InsertLabel(PasswordLabel label);

        void UpdateLabels(IEnumerable<PasswordLabel> labels);

        void DeleteLabel(PasswordLabel label);
    }
}
