﻿#define BLACK

using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Silvermoon.Windows.Styles;
using Silvermoon.Windows;
using Silvermoon.Controls;
using System.Drawing;
using Silvermoon.Shapes;
using Silvermoon.Controls.Forms;

namespace ShoppingList
{
    public static class StylePool
    {
        public static readonly StyleDictionary Main;
        public static readonly StyleDictionary Details = new MetroStyles();
        public static readonly StyleDictionary EmailDetails = new MetroStyles();

        static StylePool()
        {
            Main = new MetroStyles();
            Main.SetNamed(new LabelStyle { Name = TabPage.LabelStyleName, Font = FontPool.BigRegularFont, FontScale = 1.5f });
            Details.SetNamed(new LabelStyle { Name = TabPage.LabelStyleName, Font = FontPool.BigRegularFont, FontScale = 1.5f });
            Details.SetClass<TitleDetailsImageItem>(new TitleDetailsImageItemStyle { TitleFont = FontPool.MediumRegularFont, DetailsFont = FontPool.MediumRegularFont });
            EmailDetails.SetNamed(new LabelStyle { Name = TabPage.LabelStyleName, Font = FontPool.BigRegularFont, FontScale = 1.5f });

#if BLACK
            Main.SetClass<Window>(new WindowStyle { Background = PhoneColors.Background });
            Main.SetClass<TabControl>(new TabControlStyle { UnselectedTextColor = PhoneColors.FromArgb(128, 255, 255, 255) });
            EmailDetails.SetClass<TextBox>(new Style { Color = Color.Transparent, Chrome = Shape.Empty, TextColor = Color.White });
            EmailDetails.SetClass<ScrollViewer>(new ScrollViewerStyle { ScrollbarColor = PhoneColors.White });
            Main.SetClass<TextItem>(new TextItemStyle { Font = FontPool.BigRegularFont });
            Main.SetClass<TitleDetailsImageItem>(new TitleDetailsImageItemStyle { TitleFont = FontPool.MediumRegularFont });
#else
            Main.SetClass<Window>(new WindowStyle { Background = PhoneColors.Light });
            Main.SetClass<TabControl>(new TabControlStyle { UnselectedTextColor = PhoneColors.FromArgb(128, 0, 0, 0) });
            Main.SetClass<Page>(new WindowStyle { Background = PhoneColors.White, TextColor = PhoneColors.Black, ToolbarBackground = PhoneColors.White, ToolbarTextColor = PhoneColors.Black });
            Main.SetClass<Toolbar>(new Style { TextColor = PhoneColors.Black });
            Main.SetClass<ScrollViewer>(new ScrollViewerStyle { ScrollbarColor = PhoneColors.Black });

            EmailDetails.SetClass<ScrollViewer>(new ScrollViewerStyle { ScrollbarColor = PhoneColors.Black });
            EmailDetails.SetClass<Page>(new WindowStyle { Background = PhoneColors.White, TextColor = PhoneColors.Black, ToolbarBackground = PhoneColors.White, ToolbarTextColor = PhoneColors.Black });
            EmailDetails.SetClass<Toolbar>(new Style { TextColor = PhoneColors.Black });
            EmailDetails.SetClass<TitleDetailsImageItem>(new TitleDetailsImageItemStyle { TitleFont = FontPool.MediumRegularFont, DetailsFont = FontPool.MediumRegularFont });
            Main.SetClass<MessageDialog>(new FormStyle { Background = PhoneColors.Light, Chrome = new BorderShape { BorderSize = 2, Color = PhoneColors.Medium }, Color = PhoneColors.White, TextColor = PhoneColors.Black, TransitionManager = TransitionManagers.DialogTransitionManager, ForceTextColor = true });
            Main.SetClass<DialogButton>(new Style { TextColor = PhoneColors.Black, Background = Shape.Empty, Chrome = new BorderShape { BorderSize = 4, Color = PhoneColors.Black } });
#endif


        }


    }
}

