﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Silvermoon.OpenGL
{
    public enum LineMode 
    {
        /// <summary>
        /// All characters are in one single line. Returns and line feeds are not recognized.
        /// </summary>
        SingleLine = 0,

        /// <summary>
        /// Every line is separated by a return char.
        /// </summary>
        MultiLine = 1,

        /// <summary>
        /// Single line with end eölipsis "..." if the characters do not fit into the available area.
        /// </summary>
        EndEllipsis = 2,

        /// <summary>
        /// Every line is either separated by a return char or wrapped before a previous separator or forced to break if not separator is available.
        /// </summary>
        WordWrap = 3


    }
}
