﻿using System;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Silvermoon.OpenGL.Native.Vectors;

namespace Silvermoon.OpenGL.Native
{
    public static partial class gl
    {
        [Conditional("DEBUG")]
        public static void CheckError()
        {
            uint error = gl.GetError();
            if (error != 0) gl.ThrowError(error);
        }

        public static void ThrowError(uint error)
        {
            Debug.WriteLine(error);
        }

        #region obsolete
#if true
        public const int GL_RED = 0x1903; // from https://svn.mainia.de/svn/d11/trunk/GL/gl.d11
        public const int GL_GREEN = 0x1904;
        public const int GL_BLUE = 0x1905;
        public const int GL_COLOR_INDEX = 0x1900;

        public const int GL_VERSION_ES_CM_1_0 = 1;
        public const int GL_VERSION_ES_CL_1_0 = 1;
        public const int GL_VERSION_ES_CM_1_1 = 1;
        public const int GL_VERSION_ES_CL_1_1 = 1;
        public const int GL_DEPTH_BUFFER_BIT = 256;
        public const int GL_STENCIL_BUFFER_BIT = 1024;
        public const int GL_COLOR_BUFFER_BIT = 16384;
        public const int GL_FALSE = 0;
        public const int GL_TRUE = 1;
        public const int GL_POINTS = 0;
        public const int GL_LINES = 1;
        public const int GL_LINE_LOOP = 2;
        public const int GL_LINE_STRIP = 3;
        public const int GL_TRIANGLES = 4;
        public const int GL_TRIANGLE_STRIP = 5;
        public const int GL_TRIANGLE_FAN = 6;
        public const int GL_NEVER = 512;
        public const int GL_LESS = 513;
        public const int GL_EQUAL = 514;
        public const int GL_LEQUAL = 515;
        public const int GL_GREATER = 516;
        public const int GL_NOTEQUAL = 517;
        public const int GL_GEQUAL = 518;
        public const int GL_ALWAYS = 519;
        public const int GL_ZERO = 0;
        public const int GL_ONE = 1;
        public const int GL_SRC_COLOR = 768;
        public const int GL_ONE_MINUS_SRC_COLOR = 769;
        public const int GL_SRC_ALPHA = 770;
        public const int GL_ONE_MINUS_SRC_ALPHA = 771;
        public const int GL_DST_ALPHA = 772;
        public const int GL_ONE_MINUS_DST_ALPHA = 773;
        public const int GL_DST_COLOR = 774;
        public const int GL_ONE_MINUS_DST_COLOR = 775;
        public const int GL_SRC_ALPHA_SATURATE = 776;
        public const int GL_CLIP_PLANE0 = 12288;
        public const int GL_CLIP_PLANE1 = 12289;
        public const int GL_CLIP_PLANE2 = 12290;
        public const int GL_CLIP_PLANE3 = 12291;
        public const int GL_CLIP_PLANE4 = 12292;
        public const int GL_CLIP_PLANE5 = 12293;
        public const int GL_FRONT = 1028;
        public const int GL_BACK = 1029;
        public const int GL_FRONT_AND_BACK = 1032;
        public const int GL_FOG = 2912;
        public const int GL_LIGHTING = 2896;
        public const int GL_TEXTURE_2D = 3553;
        public const int GL_CULL_FACE = 2884;
        public const int GL_ALPHA_TEST = 3008;
        public const int GL_BLEND = 3042;
        public const int GL_COLOR_LOGIC_OP = 3058;
        public const int GL_DITHER = 3024;
        public const int GL_STENCIL_TEST = 2960;
        public const int GL_DEPTH_TEST = 2929;
        public const int GL_POINT_SMOOTH = 2832;
        public const int GL_LINE_SMOOTH = 2848;
        public const int GL_SCISSOR_TEST = 3089;
        public const int GL_COLOR_MATERIAL = 2903;
        public const int GL_NORMALIZE = 2977;
        public const int GL_RESCALE_NORMAL = 32826;
        public const int GL_POLYGON_OFFSET_FILL = 32823;
        public const int GL_VERTEX_ARRAY = 32884;
        public const int GL_NORMAL_ARRAY = 32885;
        public const int GL_COLOR_ARRAY = 32886;
        public const int GL_TEXTURE_COORD_ARRAY = 32888;
        public const int GL_MULTISAMPLE = 32925;
        public const int GL_SAMPLE_ALPHA_TO_COVERAGE = 32926;
        public const int GL_SAMPLE_ALPHA_TO_ONE = 32927;
        public const int GL_SAMPLE_COVERAGE = 32928;
        public const int GL_NO_ERROR = 0;
        public const int GL_INVALID_ENUM = 1280;
        public const int GL_INVALID_VALUE = 1281;
        public const int GL_INVALID_OPERATION = 1282;
        public const int GL_STACK_OVERFLOW = 1283;
        public const int GL_STACK_UNDERFLOW = 1284;
        public const int GL_OUT_OF_MEMORY = 1285;
        public const int GL_EXP = 2048;
        public const int GL_EXP2 = 2049;
        public const int GL_FOG_DENSITY = 2914;
        public const int GL_FOG_START = 2915;
        public const int GL_FOG_END = 2916;
        public const int GL_FOG_MODE = 2917;
        public const int GL_FOG_COLOR = 2918;
        public const int GL_CW = 2304;
        public const int GL_CCW = 2305;
        public const int GL_CURRENT_COLOR = 2816;
        public const int GL_CURRENT_NORMAL = 2818;
        public const int GL_CURRENT_TEXTURE_COORDS = 2819;
        public const int GL_POINT_SIZE = 2833;
        public const int GL_POINT_SIZE_MIN = 33062;
        public const int GL_POINT_SIZE_MAX = 33063;
        public const int GL_POINT_FADE_THRESHOLD_SIZE = 33064;
        public const int GL_POINT_DISTANCE_ATTENUATION = 33065;
        public const int GL_SMOOTH_POINT_SIZE_RANGE = 2834;
        public const int GL_LINE_WIDTH = 2849;
        public const int GL_SMOOTH_LINE_WIDTH_RANGE = 2850;
        public const int GL_ALIASED_POINT_SIZE_RANGE = 33901;
        public const int GL_ALIASED_LINE_WIDTH_RANGE = 33902;
        public const int GL_CULL_FACE_MODE = 2885;
        public const int GL_FRONT_FACE = 2886;
        public const int GL_SHADE_MODEL = 2900;
        public const int GL_DEPTH_RANGE = 2928;
        public const int GL_DEPTH_WRITEMASK = 2930;
        public const int GL_DEPTH_CLEAR_VALUE = 2931;
        public const int GL_DEPTH_FUNC = 2932;
        public const int GL_STENCIL_CLEAR_VALUE = 2961;
        public const int GL_STENCIL_FUNC = 2962;
        public const int GL_STENCIL_VALUE_MASK = 2963;
        public const int GL_STENCIL_FAIL = 2964;
        public const int GL_STENCIL_PASS_DEPTH_FAIL = 2965;
        public const int GL_STENCIL_PASS_DEPTH_PASS = 2966;
        public const int GL_STENCIL_REF = 2967;
        public const int GL_STENCIL_WRITEMASK = 2968;
        public const int GL_MATRIX_MODE = 2976;
        public const int GL_VIEWPORT = 2978;
        public const int GL_MODELVIEW_STACK_DEPTH = 2979;
        public const int GL_PROJECTION_STACK_DEPTH = 2980;
        public const int GL_TEXTURE_STACK_DEPTH = 2981;
        public const int GL_MODELVIEW_MATRIX = 2982;
        public const int GL_PROJECTION_MATRIX = 2983;
        public const int GL_TEXTURE_MATRIX = 2984;
        public const int GL_ALPHA_TEST_FUNC = 3009;
        public const int GL_ALPHA_TEST_REF = 3010;
        public const int GL_BLEND_DST = 3040;
        public const int GL_BLEND_SRC = 3041;
        public const int GL_LOGIC_OP_MODE = 3056;
        public const int GL_SCISSOR_BOX = 3088;
        public const int GL_COLOR_CLEAR_VALUE = 3106;
        public const int GL_COLOR_WRITEMASK = 3107;
        public const int GL_UNPACK_ALIGNMENT = 3317;
        public const int GL_PACK_ALIGNMENT = 3333;
        public const int GL_MAX_LIGHTS = 3377;
        public const int GL_MAX_CLIP_PLANES = 3378;
        public const int GL_MAX_TEXTURE_SIZE = 3379;
        public const int GL_MAX_MODELVIEW_STACK_DEPTH = 3382;
        public const int GL_MAX_PROJECTION_STACK_DEPTH = 3384;
        public const int GL_MAX_TEXTURE_STACK_DEPTH = 3385;
        public const int GL_MAX_VIEWPORT_DIMS = 3386;
        public const int GL_MAX_TEXTURE_UNITS = 34018;
        public const int GL_SUBPIXEL_BITS = 3408;
        public const int GL_RED_BITS = 3410;
        public const int GL_GREEN_BITS = 3411;
        public const int GL_BLUE_BITS = 3412;
        public const int GL_ALPHA_BITS = 3413;
        public const int GL_DEPTH_BITS = 3414;
        public const int GL_STENCIL_BITS = 3415;
        public const int GL_POLYGON_OFFSET_UNITS = 10752;
        public const int GL_POLYGON_OFFSET_FACTOR = 32824;
        public const int GL_TEXTURE_BINDING_2D = 32873;
        public const int GL_VERTEX_ARRAY_SIZE = 32890;
        public const int GL_VERTEX_ARRAY_TYPE = 32891;
        public const int GL_VERTEX_ARRAY_STRIDE = 32892;
        public const int GL_NORMAL_ARRAY_TYPE = 32894;
        public const int GL_NORMAL_ARRAY_STRIDE = 32895;
        public const int GL_COLOR_ARRAY_SIZE = 32897;
        public const int GL_COLOR_ARRAY_TYPE = 32898;
        public const int GL_COLOR_ARRAY_STRIDE = 32899;
        public const int GL_TEXTURE_COORD_ARRAY_SIZE = 32904;
        public const int GL_TEXTURE_COORD_ARRAY_TYPE = 32905;
        public const int GL_TEXTURE_COORD_ARRAY_STRIDE = 32906;
        public const int GL_VERTEX_ARRAY_POINTER = 32910;
        public const int GL_NORMAL_ARRAY_POINTER = 32911;
        public const int GL_COLOR_ARRAY_POINTER = 32912;
        public const int GL_TEXTURE_COORD_ARRAY_POINTER = 32914;
        public const int GL_SAMPLE_BUFFERS = 32936;
        public const int GL_SAMPLES = 32937;
        public const int GL_SAMPLE_COVERAGE_VALUE = 32938;
        public const int GL_SAMPLE_COVERAGE_INVERT = 32939;
        public const int GL_NUM_COMPRESSED_TEXTURE_FORMATS = 34466;
        public const int GL_COMPRESSED_TEXTURE_FORMATS = 34467;
        public const int GL_DONT_CARE = 4352;
        public const int GL_FASTEST = 4353;
        public const int GL_NICEST = 4354;
        public const int GL_PERSPECTIVE_CORRECTION_HINT = 3152;
        public const int GL_POINT_SMOOTH_HINT = 3153;
        public const int GL_LINE_SMOOTH_HINT = 3154;
        public const int GL_FOG_HINT = 3156;
        public const int GL_GENERATE_MIPMAP_HINT = 33170;
        public const int GL_LIGHT_MODEL_AMBIENT = 2899;
        public const int GL_LIGHT_MODEL_TWO_SIDE = 2898;
        public const int GL_AMBIENT = 4608;
        public const int GL_DIFFUSE = 4609;
        public const int GL_SPECULAR = 4610;
        public const int GL_POSITION = 4611;
        public const int GL_SPOT_DIRECTION = 4612;
        public const int GL_SPOT_EXPONENT = 4613;
        public const int GL_SPOT_CUTOFF = 4614;
        public const int GL_CONSTANT_ATTENUATION = 4615;
        public const int GL_LINEAR_ATTENUATION = 4616;
        public const int GL_QUADRATIC_ATTENUATION = 4617;
        public const int GL_BYTE = 5120;
        public const int GL_UNSIGNED_BYTE = 5121;
        public const int GL_SHORT = 5122;
        public const int GL_UNSIGNED_SHORT = 5123;
        public const int GL_FLOAT = 5126;
        public const int GL_FIXED = 5132;
        public const int GL_CLEAR = 5376;
        public const int GL_AND = 5377;
        public const int GL_AND_REVERSE = 5378;
        public const int GL_COPY = 5379;
        public const int GL_AND_INVERTED = 5380;
        public const int GL_NOOP = 5381;
        public const int GL_XOR = 5382;
        public const int GL_OR = 5383;
        public const int GL_NOR = 5384;
        public const int GL_EQUIV = 5385;
        public const int GL_INVERT = 5386;
        public const int GL_OR_REVERSE = 5387;
        public const int GL_COPY_INVERTED = 5388;
        public const int GL_OR_INVERTED = 5389;
        public const int GL_NAND = 5390;
        public const int GL_SET = 5391;
        public const int GL_EMISSION = 5632;
        public const int GL_SHININESS = 5633;
        public const int GL_AMBIENT_AND_DIFFUSE = 5634;
        public const int GL_MODELVIEW = 5888;
        public const int GL_PROJECTION = 5889;
        public const int GL_TEXTURE = 5890;
        public const int GL_ALPHA = 6406;
        public const int GL_RGB = 6407;
        public const int GL_RGBA = 6408;
        public const int GL_LUMINANCE = 6409;
        public const int GL_LUMINANCE_ALPHA = 6410;
        public const int GL_UNSIGNED_SHORT_4_4_4_4 = 32819;
        public const int GL_UNSIGNED_SHORT_5_5_5_1 = 32820;
        public const int GL_UNSIGNED_SHORT_5_6_5 = 33635;
        public const int GL_FLAT = 7424;
        public const int GL_SMOOTH = 7425;
        public const int GL_KEEP = 7680;
        public const int GL_REPLACE = 7681;
        public const int GL_INCR = 7682;
        public const int GL_DECR = 7683;
        public const int GL_EXTENSIONS = 7939;
        public const int GL_MODULATE = 8448;
        public const int GL_DECAL = 8449;
        public const int GL_ADD = 260;
        public const int GL_TEXTURE_ENV_MODE = 8704;
        public const int GL_TEXTURE_ENV_COLOR = 8705;
        public const int GL_TEXTURE_ENV = 8960;
        public const int GL_NEAREST = 9728;
        public const int GL_LINEAR = 9729;
        public const int GL_NEAREST_MIPMAP_NEAREST = 9984;
        public const int GL_LINEAR_MIPMAP_NEAREST = 9985;
        public const int GL_NEAREST_MIPMAP_LINEAR = 9986;
        public const int GL_LINEAR_MIPMAP_LINEAR = 9987;
        public const int GL_TEXTURE_MAG_FILTER = 10240;
        public const int GL_TEXTURE_MIN_FILTER = 10241;
        public const int GL_TEXTURE_WRAP_S = 10242;
        public const int GL_TEXTURE_WRAP_T = 10243;
        public const int GL_GENERATE_MIPMAP = 33169;
        public const int GL_TEXTURE0 = 33984;
        public const int GL_TEXTURE1 = 33985;
        //public const int GL_TEXTURE2 = 33986;
        //public const int GL_TEXTURE3 = 33987;
        //public const int GL_TEXTURE4 = 33988;
        //public const int GL_TEXTURE5 = 33989;
        //public const int GL_TEXTURE6 = 33990;
        //public const int GL_TEXTURE7 = 33991;
        //public const int GL_TEXTURE8 = 33992;
        //public const int GL_TEXTURE9 = 33993;
        //public const int GL_TEXTURE10 = 33994;
        //public const int GL_TEXTURE11 = 33995;
        //public const int GL_TEXTURE12 = 33996;
        //public const int GL_TEXTURE13 = 33997;
        //public const int GL_TEXTURE14 = 33998;
        //public const int GL_TEXTURE15 = 33999;
        //public const int GL_TEXTURE16 = 34000;
        //public const int GL_TEXTURE17 = 34001;
        //public const int GL_TEXTURE18 = 34002;
        //public const int GL_TEXTURE19 = 34003;
        //public const int GL_TEXTURE20 = 34004;
        //public const int GL_TEXTURE21 = 34005;
        //public const int GL_TEXTURE22 = 34006;
        //public const int GL_TEXTURE23 = 34007;
        //public const int GL_TEXTURE24 = 34008;
        //public const int GL_TEXTURE25 = 34009;
        //public const int GL_TEXTURE26 = 34010;
        //public const int GL_TEXTURE27 = 34011;
        //public const int GL_TEXTURE28 = 34012;
        //public const int GL_TEXTURE29 = 34013;
        //public const int GL_TEXTURE30 = 34014;
        //public const int GL_TEXTURE31 = 34015;
        public const int GL_ACTIVE_TEXTURE = 34016;
        public const int GL_CLIENT_ACTIVE_TEXTURE = 34017;
        public const int GL_REPEAT = 10497;
        public const int GL_CLAMP_TO_EDGE = 33071;
        public const int GL_LIGHT0 = 16384;
        public const int GL_LIGHT1 = 16385;
        public const int GL_LIGHT2 = 16386;
        public const int GL_LIGHT3 = 16387;
        public const int GL_LIGHT4 = 16388;
        public const int GL_LIGHT5 = 16389;
        public const int GL_LIGHT6 = 16390;
        public const int GL_LIGHT7 = 16391;
        public const int GL_ARRAY_BUFFER = 34962;
        public const int GL_ELEMENT_ARRAY_BUFFER = 34963;
        public const int GL_ARRAY_BUFFER_BINDING = 34964;
        public const int GL_ELEMENT_ARRAY_BUFFER_BINDING = 34965;
        public const int GL_VERTEX_ARRAY_BUFFER_BINDING = 34966;
        public const int GL_NORMAL_ARRAY_BUFFER_BINDING = 34967;
        public const int GL_COLOR_ARRAY_BUFFER_BINDING = 34968;
        public const int GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING = 34970;
        public const int GL_STATIC_DRAW = 35044;
        public const int GL_DYNAMIC_DRAW = 35048;
        public const int GL_BUFFER_SIZE = 34660;
        public const int GL_BUFFER_USAGE = 34661;
        public const int GL_SUBTRACT = 34023;
        public const int GL_COMBINE = 34160;
        public const int GL_COMBINE_RGB = 34161;
        public const int GL_COMBINE_ALPHA = 34162;
        public const int GL_RGB_SCALE = 34163;
        public const int GL_ADD_SIGNED = 34164;
        public const int GL_INTERPOLATE = 34165;
        public const int GL_CONSTANT = 34166;
        public const int GL_PRIMARY_COLOR = 34167;
        public const int GL_PREVIOUS = 34168;
        public const int GL_OPERAND0_RGB = 34192;
        public const int GL_OPERAND1_RGB = 34193;
        public const int GL_OPERAND2_RGB = 34194;
        public const int GL_OPERAND0_ALPHA = 34200;
        public const int GL_OPERAND1_ALPHA = 34201;
        public const int GL_OPERAND2_ALPHA = 34202;
        public const int GL_ALPHA_SCALE = 3356;
        public const int GL_SRC0_RGB = 34176;
        public const int GL_SRC1_RGB = 34177;
        public const int GL_SRC2_RGB = 34178;
        public const int GL_SRC0_ALPHA = 34184;
        public const int GL_SRC1_ALPHA = 34185;
        public const int GL_SRC2_ALPHA = 34186;
        public const int GL_DOT3_RGB = 34478;
        public const int GL_DOT3_RGBA = 34479;
        public const int GL_IMPLEMENTATION_COLOR_READ_TYPE_OES = 35738;
        public const int GL_IMPLEMENTATION_COLOR_READ_FORMAT_OES = 35739;
        public const int GL_PALETTE4_RGB8_OES = 35728;
        public const int GL_PALETTE4_RGBA8_OES = 35729;
        public const int GL_PALETTE4_R5_G6_B5_OES = 35730;
        public const int GL_PALETTE4_RGBA4_OES = 35731;
        public const int GL_PALETTE4_RGB5_A1_OES = 35732;
        public const int GL_PALETTE8_RGB8_OES = 35733;
        public const int GL_PALETTE8_RGBA8_OES = 35734;
        public const int GL_PALETTE8_R5_G6_B5_OES = 35735;
        public const int GL_PALETTE8_RGBA4_OES = 35736;
        public const int GL_PALETTE8_RGB5_A1_OES = 35737;
        public const int GL_POINT_SIZE_ARRAY_OES = 35740;
        public const int GL_POINT_SIZE_ARRAY_TYPE_OES = 35210;
        public const int GL_POINT_SIZE_ARRAY_STRIDE_OES = 35211;
        public const int GL_POINT_SIZE_ARRAY_POINTER_OES = 35212;
        public const int GL_POINT_SIZE_ARRAY_BUFFER_BINDING_OES = 35743;
        public const int GL_POINT_SPRITE_OES = 34913;
        public const int GL_COORD_REPLACE_OES = 34914;
#endif
        #endregion
        public const int GL_RENDERER = 7937;
        public const int GL_VENDOR = 7936;
        public const int GL_VERSION = 7938;
        public const int GL_OES_read_format = 1;
        public const int GL_OES_compressed_paletted_texture = 1;
        public const int GL_OES_point_size_array = 1;
        public const int GL_OES_point_sprite = 1;

        public const int CLV = 1 << 16;

        public const int GL_TEXTURE_CROP_RECT_OES = 0x8b9d;

        const string LibGlesDllName = "libgles_cm.dll";


        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDrawTexiOES")]
        public static extern void DrawTexOES(int x, int y, int z, int width, int height);


        [DllImportAttribute(LibGlesDllName, EntryPoint = "glAlphaFunc")]
        public static extern void AlphaFunc(Comparison func, float reference);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glClearColor")]
        public static extern void ClearColor(float red, float green, float blue, float alpha);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glClearDepthf")]
        public static extern void ClearDepthf(float depth);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glClipPlanef")]
        public static extern void ClipPlanef(uint plane, float[] equation);

        /// <summary>
        /// Sets the current color.
        /// </summary>
        /// <param name="red">A value between 0F and 1F.</param>
        /// <param name="green">A value between 0F and 1F.</param>
        /// <param name="blue">A value between 0F and 1F.</param>
        /// <param name="alpha">A value between 0F and 1F.</param>
        [DllImportAttribute(LibGlesDllName, EntryPoint = "glColor4f")]
        public static extern void Color4f(float red, float green, float blue, float alpha);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDepthRangef")]
        public static extern void DepthRangef(float zNear, float zFar);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glFogf")]
        public static extern void Fog(FogParam param, float value);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glFogfv")]
        public static extern void Fog(FogParam param, float[] values);

        /// <summary>
        /// The glFrustum function multiplies the current matrix by a perspective matrix.
        /// http://msdn.microsoft.com/en-us/library/dd373537(VS.85).aspx
        /// </summary>
        /// <param name="left">The coordinate for the left-vertical clipping plane.</param>
        /// <param name="right">The coordinate for the right-vertical clipping plane.</param>
        /// <param name="bottom">The coordinate for the bottom-horizontal clipping plane.</param>
        /// <param name="top">The coordinate for the bottom-horizontal clipping plane. </param>
        /// <param name="zNear">The distances to the near-depth clipping plane. Must be positive.</param>
        /// <param name="zFar">The distances to the far-depth clipping planes. Must be positive.</param>
        [DllImportAttribute(LibGlesDllName, EntryPoint = "glFrustumf")]
        public static extern void Frustumf(float left, float right, float bottom, float top, float zNear, float zFar);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetFloatv")]
        private static extern void glGetFloatv(ParameterName pname, out float value);

        public static float GetFloatValue(ParameterName name)
        {
            float result;
            glGetFloatv(name, out result);
            return result;
        }

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetLightfv")]
        public static extern void GetLightfv(uint light, uint pname, float[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetMaterialfv")]
        public static extern void GetMaterialfv(uint face, uint pname, float[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetTexEnvfv")]
        public static extern void GetTexEnvfv(uint env, uint pname, float[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetTexParameterfv")]
        public static extern void GetTexParameterfv(TextureTarget target, uint pname, float[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLightModelf")]
        public static extern void LightModelf(uint pname, float param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLightModelfv")]
        public static extern void LightModelfv(uint pname, float[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLightf")]
        public static extern void Lightf(uint light, uint pname, float param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLightfv")]
        public static extern void Lightfv(uint light, uint pname, float[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLineWidth")]
        public static extern void LineWidth(float width);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLoadMatrixf")]
        public static extern void LoadMatrixf(float[] m);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glMaterialf")]
        public static extern void Materialf(uint face, uint pname, float param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glMaterialfv")]
        public static extern void Materialfv(uint face, uint pname, float[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glMultMatrixf")]
        public static extern void MultMatrixf(float[] m);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glMultiTexCoord4f")]
        public static extern void MultiTexCoord4f(TextureTarget target, float s, float t, float r, float q);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glNormal3f")]
        public static extern void Normal3f(float nx, float ny, float nz);

        /// <summary>
        /// The glOrtho function multiplies the current matrix by an orthographic matrix.
        /// http://msdn.microsoft.com/en-us/library/dd373965(VS.85).aspx
        /// </summary>
        /// <param name="left">The coordinates for the left and right vertical clipping planes.</param>
        /// <param name="right">The coordinates for the left and right vertical clipping planes.</param>
        /// <param name="bottom">The coordinates for the bottom and top horizontal clipping planes.</param>
        /// <param name="top">The coordinates for the bottom and top horizontal clipping planes.</param>
        /// <param name="zNear">The distances to the nearer and farther depth clipping planes. These distances are negative if the plane is to be behind the viewer.</param>
        /// <param name="zFar">The distances to the nearer and farther depth clipping planes. These distances are negative if the plane is to be behind the viewer.</param>
        [DllImportAttribute(LibGlesDllName, EntryPoint = "glOrthof")]
        public static extern void Orthof(float left, float right, float bottom, float top, float zNear, float zFar);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPointParameterf")]
        public static extern void PointParameterf(uint pname, float param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPointParameterfv")]
        public static extern void PointParameterfv(uint pname, float[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPointSize")]
        public static extern void PointSize(float size);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPolygonOffset")]
        public static extern void PolygonOffset(float factor, float units);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glRotatef")]
        public static extern void Rotatef(float angle, float x, float y, float z);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glScalef")]
        public static extern void Scalef(float x, float y, float z);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexEnvf")]
        public static extern void TexEnvf(TextureTarget target, uint pname, float param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexEnvfv")]
        public static extern void TexEnvfv(TextureTarget target, uint pname, float[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexParameterf")]
        public static extern void TexParameterf(TextureTarget target, uint pname, float param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexParameterfv")]
        public static extern void TexParameterfv(TextureTarget target, uint pname, float[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTranslatef")]
        public static extern void Translatef(float x, float y, float z);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glActiveTexture")]
        public static extern void ActiveTexture(TextureUnit texture);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glAlphaFuncx")]
        public static extern void AlphaFuncx(uint func, int @ref);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glBindBuffer")]
        public static extern void BindBuffer(BufferTarget target, uint bufferName);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glBindTexture")]
        public static extern void BindTexture(TextureTarget target, uint texture);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glBlendFunc")]
        public static extern void BlendFunc(BlendFactor sourceFactor, BlendFactor destFactor);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glBufferData")]
        public static extern void BufferData<T>(BufferTarget target, int size, T[] data, BufferUsage usage);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glBufferData")]
        public static extern void BufferData(BufferTarget target, int size, System.IntPtr data, BufferUsage usage);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glBufferData")]
        public static extern void BufferData(BufferTarget target, int size, int[] data, BufferUsage usage);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glBufferData")]
        public static extern void BufferData(BufferTarget target, int size, short[] data, BufferUsage usage);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glBufferData")]
        public static extern void BufferData(BufferTarget target, int size, float[] data, BufferUsage usage);


        [DllImportAttribute(LibGlesDllName, EntryPoint = "glBufferSubData")]
        public static extern void BufferSubData(TextureTarget target, int offset, int size, System.IntPtr data);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glClear")]
        public static extern void Clear(ColorBufferBit mask);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glClearColorx")]
        public static extern void ClearColorx(int red, int green, int blue, int alpha);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glClearDepthx")]
        public static extern void ClearDepthx(int depth);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glClearStencil")]
        public static extern void ClearStencil(int s);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glClientActiveTexture")]
        public static extern void ClientActiveTexture(TextureUnit texture);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glClipPlanex")]
        public static extern void ClipPlanex(uint plane, int[] equation);

        //[DllImportAttribute(LibGlesDllName, EntryPoint = "glColor4ub")]
        //public static extern void Color4ub(byte red, byte green, byte blue, byte alpha);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glColor4x")]
        public static extern void Color4x(int red, int green, int blue, int alpha);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glColorMask")]
        public static extern void ColorMask(byte red, byte green, byte blue, byte alpha);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glColorPointer")]
        public static extern void ColorPointer(int size, glValueType type, int stride, IntPtr data);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glColorPointer")]
        public static extern void ColorPointer(int size, glValueType type, int stride, int[] data);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glColorPointer")]
        public static extern void ColorPointer(int size, glValueType type, int stride, byte[] data);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glColorPointer")]
        public static extern void ColorPointer(int size, glValueType type, int stride, float[] data);





        [DllImportAttribute(LibGlesDllName, EntryPoint = "glCompressedTexImage2D")]
        public static extern void CompressedTexImage2D(TextureTarget target, int level, GlesPixelFormat internalformat, int width, int height, int border, int imageSize, System.IntPtr data);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glCompressedTexSubImage2D")]
        public static extern void CompressedTexSubImage2D(TextureTarget target, int level, int xoffset, int yoffset, int width, int height, uint format, int imageSize, System.IntPtr data);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glCopyTexImage2D")]
        public static extern int CopyTexImage2D(TextureTarget target, int level, GlesPixelFormat internalformat, int x, int y, int width, int height, int border);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glCopyTexSubImage2D")]
        public static extern void CopyTexSubImage2D(TextureTarget target, int level, int xoffset, int yoffset, int x, int y, int width, int height);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glCullFace")]
        public static extern void CullFace(CullFaceMode mode);

        //[DllImportAttribute(LibGlesDllName, EntryPoint = "glDeleteBuffers")]
        //private static extern void glDeleteBuffers(int n, ref uint buffer);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDeleteBuffers")]
        private static extern void glDeleteBuffers(int n, uint[] buffers);

        public static void DeleteBuffer(uint bufferName)
        {
            if (egl.IsActive)
            {
                uint[] buffers = new uint[] { bufferName };
                glDeleteBuffers(1, buffers);
            }
            else Debug.WriteLine("Call of DeleteBuffer after context was disposed.");
        }

        public static void DeleteBuffers(uint[] buffers)
        {
            if (egl.IsActive)
            {
                if (buffers != null) glDeleteBuffers(buffers.Length, buffers);
            }
            else Debug.WriteLine("Call of DeleteBuffers after context was disposed.");
        }

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDeleteTextures")]
        private static extern void glDeleteTextures(int n, ref uint textures);

        public static void DeleteTexture(uint textures)
        {
            if (egl.IsActive) glDeleteTextures(1, ref textures); else Debug.WriteLine("Call of DeleteTexutre after context was disposed.");
        }

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDepthFunc")]
        public static extern void DepthFunc(Comparison func);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDepthMask")]
        public static extern void DepthMask(byte flag);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDepthRangex")]
        public static extern void DepthRangex(int zNear, int zFar);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDisable")]
        public static extern void Disable(Capability capability);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDisableClientState")]
        public static extern void DisableClientState(ClientStateArray array);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDrawArrays")]
        public static extern void DrawArrays(PrimitiveType mode, int first, int count);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDrawElements")]
        public static unsafe extern void DrawElements(PrimitiveType mode, int count, glValueType type, void* indices);


        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDrawElements")]
        public static extern void DrawElements(PrimitiveType mode, int count, glValueType type, short[] indices);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDrawElements")]
        public static extern void DrawElements(PrimitiveType mode, int count, glValueType type, int[] indices);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glDrawElements")]
        public static extern void DrawElements(PrimitiveType mode, int count, glValueType type, float[] indices);


        [DllImportAttribute(LibGlesDllName, EntryPoint = "glEnable")]
        public static extern void Enable(Capability capability);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glEnableClientState")]
        public static extern void EnableClientState(ClientStateArray array);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glFinish")]
        public static extern void Finish();

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glFlush")]
        public static extern void Flush();

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glFogx")]
        public static extern void Fog(FogParam param, int value);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glFogx")]
        public static extern void Fog(FogParam param, FogMode mode);


        [DllImportAttribute(LibGlesDllName, EntryPoint = "glFogxv")]
        public static extern void Fog(FogParam param, int[] values);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glFrontFace")]
        public static extern void FrontFace(uint mode);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glFrustumx")]
        public static extern void Frustumx(int left, int right, int bottom, int top, int zNear, int zFar);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetBooleanv")]
        private static extern void glGetBooleanv(ParameterName pname, out bool value);

        public static bool GetBoolValue(ParameterName parameterName)
        {
            bool result;
            glGetBooleanv(parameterName, out result);
            return result;
        }

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetBufferParameteriv")]
        public static extern void GetBufferParameteriv(TextureTarget target, uint pname, int[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGenBuffers")]
        private static extern void glGenBuffers(int numBuffers, out uint buffer);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGenBuffers")]
        private static extern void glGenBuffers(int numBuffers, uint[] buffer);

        public static uint[] GenBuffers(int numBuffers)
        {

            uint[] result = new uint[numBuffers];
            glGenBuffers(numBuffers, result);
            return result;
        }

        public static uint GenBuffer()
        {
            uint result;
            glGenBuffers(1, out result);
            return result;
        }

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGenTextures")]
        private static extern void glGenTextures(int numTextures, out uint textures);

        public static uint GenTexture()
        {
            uint result;
            glGenTextures(1, out result);
            return result;
        }

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetError")]
        public static extern uint GetError();

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetFixedv")]
        public static extern void GetFixedv(uint pname, int[] @params);

        /// <summary>
        /// Gets a value. <see cref="TextureUnit"/>.
        /// </summary>
        /// <param name="value">The output for the number of units to get.</param>
        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetIntegerv")]
        private static extern void glGetIntegerv(ParameterName pname, out int value);

        public static int GetIntegerValue(ParameterName paramName)
        {
            int value = -1;
            glGetIntegerv(paramName, out value);
            return value;
        }

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetLightxv")]
        public static extern void GetLightxv(uint light, uint pname, ref int value);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetMaterialxv")]
        public static extern void GetMaterialxv(uint face, uint pname, out int value);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetPointerv")]
        public static extern void GetPointerv(uint pname, IntPtr[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetString")]
        public static extern IntPtr _GetString(uint name);

        public static string GetString(uint name)
        {
            IntPtr mem = _GetString(name);
            if (mem == IntPtr.Zero) return "";
            byte[] b = new byte[1000];

            int l = 0;
            while (l < b.Length)
            {
                byte x = Marshal.ReadByte(mem, l);
                b[l] = x;
                if (x == 0) break;
                l++;
            }
            string s = Encoding.ASCII.GetString(b, 0, l);
            return s;
        }

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetTexEnviv")]
        public static extern void GetTexEnviv(uint env, uint pname, out int value);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetTexEnvxv")]
        public static extern void GetTexEnvxv(uint env, uint pname, out int value);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetTexParameteriv")]
        public static extern void GetTexParameteriv(TextureTarget target, uint pname, int[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetTexParameterxv")]
        public static extern void GetTexParameterxv(TextureTarget target, uint pname, int[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glHint")]
        public static extern void Hint(HintTarget target, HintMode mode);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glIsBuffer")]
        public static extern byte IsBuffer(uint buffer);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glIsEnabled")]
        public static extern byte IsEnabled(Capability capability);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glIsTexture")]
        public static extern byte IsTexture(uint texture);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLightModelx")]
        public static extern void LightModelx(uint pname, int param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLightModelxv")]
        public static extern void LightModelxv(uint pname, int[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLightx")]
        public static extern void Lightx(uint light, uint pname, int param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLightxv")]
        public static extern void Lightxv(uint light, uint pname, int[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLineWidthx")]
        public static extern void LineWidthx(int width);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLoadIdentity")]
        public static extern void LoadIdentity();

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLoadMatrixx")]
        public static extern void LoadMatrixx(int[] m);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glLogicOp")]
        public static extern void LogicOp(uint opcode);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glMaterialx")]
        public static extern void Materialx(uint face, uint pname, int param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glMaterialxv")]
        public static extern void Materialxv(uint face, uint pname, int[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glMatrixMode")]
        public static extern void MatrixMode(MatrixMode mode);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glMultMatrixx")]
        public static extern void MultMatrixx(int[] m);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glMultiTexCoord4x")]
        public static extern void MultiTexCoord4x(TextureTarget target, int s, int t, int r, int q);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glNormal3x")]
        public static extern void Normal3x(int nx, int ny, int nz);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glNormalPointer")]
        public static extern void NormalPointer(uint type, int stride, System.IntPtr pointer);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glOrthox")]
        public static extern void Orthox(int left, int right, int bottom, int top, int zNear, int zFar);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPixelStorei")]
        public static extern void PixelStorei(PixelStoreParam pname, PixelStoreValue param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPointParameterx")]
        public static extern void PointParameterx(uint pname, int param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPointParameterxv")]
        public static extern void PointParameterxv(uint pname, int[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPointSizex")]
        public static extern void PointSizex(int size);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPolygonOffsetx")]
        public static extern void PolygonOffsetx(int factor, int units);

        /// <summary>
        /// Gets the last matrix from stack.
        /// </summary>
        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPopMatrix")]
        public static extern void PopMatrix();

        /// <summary>
        /// Pushes the current matrix to the stack.
        /// </summary>
        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPushMatrix")]
        public static extern void PushMatrix();

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glReadPixels")]
        public static extern void ReadPixels(int x, int y, int width, int height, uint format, glValueType type, IntPtr pixels);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glReadPixels")]
        public static extern void ReadPixels(int x, int y, int width, int height, uint format, glValueType type, ref byte[] pixels);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glRotatex")]
        public static extern void Rotatex(int angle, int x, int y, int z);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glSampleCoverage")]
        public static extern void SampleCoverage(float value, byte invert);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glSampleCoveragex")]
        public static extern void SampleCoveragex(int value, byte invert);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glScalex")]
        public static extern void Scalex(int x, int y, int z);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glScissor")]
        public static extern void Scissor(int x, int y, int width, int height);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glShadeModel")]
        public static extern void ShadeModel(ShadeModel mode);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glStencilFunc")]
        public static extern void StencilFunc(Comparison func, int reference, uint mask);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glStencilMask")]
        public static extern void StencilMask(uint mask);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glStencilOp")]
        public static extern void StencilOp(uint fail, uint zfail, uint zpass);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexCoordPointer")]
        public static extern void TexCoordPointer(int size, glValueType type, int stride, float[] data);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexCoordPointer")]
        public static extern void TexCoordPointer(int size, glValueType type, int stride, int[] data);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexCoordPointer")]
        public static extern void TexCoordPointer(int size, glValueType type, int stride, short[] data);


        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexCoordPointer")]
        public static extern void TexCoordPointer(int size, glValueType type, int stride, System.IntPtr pointer);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexEnvx")]
        public static extern void TexEnvi(TextureTarget target, uint pname, int param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexEnvx")]
        public static extern void TexEnvx(TextureTarget target, uint pname, int param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexEnviv")]
        public static extern void TexEnviv(TextureTarget target, uint pname, int[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexEnvxv")]
        public static extern void TexEnvxv(TextureTarget target, uint pname, int[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexImage2D")]
        public static extern void TexImage2D(TextureTarget target, int level, GlesPixelFormat internalformat, int width, int height, int border, GlesPixelFormat format, glValueType type, System.IntPtr pixels);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexParameteri")]
        public static extern void TexParameteri(TextureTarget target, TextureFilter pname, TextureParam param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexParameterx")]
        public static extern void TexParameterx(TextureTarget target, TextureFilter pname, TextureParam param);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexParameteriv")]
        public static extern void TexParameteriv(TextureTarget target, uint TextureFilter, TextureParam[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexParameteriv")]
        public static extern void TexParameteriv(TextureTarget target, uint TextureFilter, int[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexParameterxv")]
        public static extern void TexParameterxv(TextureTarget target, TextureFilter pname, TextureParam[] @params);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTexSubImage2D")]
        public static extern void TexSubImage2D(TextureTarget target, int level, int xoffset, int yoffset, int width, int height, uint format, uint type, System.IntPtr pixels);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glTranslatex")]
        public static extern void Translatex(int x, int y, int z);

        /// <summary>
        /// The glVertexPointer function defines an array of vertex data.
        /// </summary>
        /// <param name="size">The number of coordinates per vertex. The value of size must be 2, 3, or 4.</param>
        /// <param name="type">The data type of each coordinate in the array using the following symbolic constants: GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE. </param>
        /// <param name="stride">The byte offset between consecutive vertices. When stride is zero, the vertices are tightly packed in the array. </param>
        /// <param name="pointer">A pointer to the first coordinate of the first vertex in the array.</param>
        [DllImportAttribute(LibGlesDllName, EntryPoint = "glVertexPointer")]
        public static extern void VertexPointer(int size, glValueType type, int stride, short[] array);



        /// <summary>
        /// The glVertexPointer function defines an array of vertex data.
        /// </summary>
        /// <param name="size">The number of coordinates per vertex. The value of size must be 2, 3, or 4.</param>
        /// <param name="type">The data type of each coordinate in the array using the following symbolic constants: GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE. </param>
        /// <param name="stride">The byte offset between consecutive vertices. When stride is zero, the vertices are tightly packed in the array. </param>
        /// <param name="pointer">A pointer to the first coordinate of the first vertex in the array.</param>
        [DllImportAttribute(LibGlesDllName, EntryPoint = "glVertexPointer")]
        public static extern void VertexPointer(int size, glValueType type, int stride, System.IntPtr pointer);



        /// <summary>
        /// The glVertexPointer function defines an array of vertex data.
        /// </summary>
        /// <param name="size">The number of coordinates per vertex. The value of size must be 2, 3, or 4.</param>
        /// <param name="type">The data type of each coordinate in the array using the following symbolic constants: GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE. </param>
        /// <param name="stride">The byte offset between consecutive vertices. When stride is zero, the vertices are tightly packed in the array. </param>
        /// <param name="pointer">A pointer to the first coordinate of the first vertex in the array.</param>
        [DllImportAttribute(LibGlesDllName, EntryPoint = "glVertexPointer")]
        public static extern void VertexPointer(int size, glValueType type, int stride, float[] array);

        /// <summary>
        /// The glVertexPointer function defines an array of vertex data.
        /// </summary>
        /// <param name="size">The number of coordinates per vertex. The value of size must be 2, 3, or 4.</param>
        /// <param name="type">The data type of each coordinate in the array using the following symbolic constants: GL_SHORT, GL_INT, GL_FLOAT, and GL_DOUBLE. </param>
        /// <param name="stride">The byte offset between consecutive vertices. When stride is zero, the vertices are tightly packed in the array. </param>
        /// <param name="pointer">A pointer to the first coordinate of the first vertex in the array.</param>
        [DllImportAttribute(LibGlesDllName, EntryPoint = "glVertexPointer")]
        public static extern void VertexPointer(int size, glValueType type, int stride, int[] array);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glViewport")]
        public static extern void Viewport(int x, int y, int width, int height);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glPointSizePointerOES")]
        public static extern void PointSizePointerOES(uint type, int stride, System.IntPtr pointer);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetClipPlanef")]
        public static extern void GetClipPlanef(uint pname, float[] eqn);

        [DllImportAttribute(LibGlesDllName, EntryPoint = "glGetClipPlanex")]
        public static extern void GetClipPlanex(uint pname, int[] eqn);
    }

    public enum ShadeModel
    {
        Smoth = 7425,
        Flat = 7424
    };

    public enum Capability : uint
    {
        AlphaTest = 3008,
        Blend = 3042,
        ClipPlane0 = 12288,
        ClipPlane1 = 12289,
        ClipPlane2 = 12290,
        ClipPlane3 = 12291,
        ClipPlane4 = 12292,
        ClipPlane5 = 12293,
        //        ClipPlane6=12294,
        ColorLogicOp = 3058,
        ColorMaterial = 2903,
        CullFace = 2884,
        DepthTest = 2929,
        Dither = 3024,
        Fog = 2912,
        IndexLogicOpMode = 3056,
        Light0 = 16384,
        Light1 = 16385,
        Light2 = 16386,
        Light3 = 16387,
        Light4 = 16388,
        Light5 = 16389,
        Light6 = 16390,
        Light7 = 16391,
        Lightening = 2896,
        LineSmooth = 2848,
        LogicOpMode = 3056,
        Normalize = 2977,
        PointSmooth = 2832,
        PolygonOffsetFill = 32823,
        ScissorBox = 3088,
        ScissorTest = 3089,
        StencilTest = 2960,
        Texture2D = 3553,
        #region not supported
        //  AutoNormal,
        //LineStripple=3,
        //Map1_Color4,
        //Map1Normal,
        //Map1TextureCoord1,
        //Map1TextureCoord2,
        //Map1TextureCoord3,
        //Map1TextureCoord4,
        //Map1Vertex3,
        //Map1Vertex4,
        //Map2Color4,
        //Map2Index,
        //Map2Normal,
        //Map2TextureCoord1,
        //Map2TextureCoord2,
        //Map2TextureCoord3,
        //Map2TextureCoord4,
        //Map2Vertext3,
        //Map2Vertext4,
        //Texture1D,
        //PolygonOffsetLine,
        //PolygonOffsetPoint,
        //PolygonOffsetStripple,
        //PolygonStripple,
        //TextureGenQ,
        //TextureGenR,
        //TextureGenS,
        //TextureGenT
        #endregion
    }

    public enum BufferTarget : uint
    {
        ArrayBuffer = 34962,
        ElementArrayBuffer = 34963
    }

    public enum BufferUsage : uint
    {
        StaticDraw = 35044,
        DynamicDraw = 35048
    }


    public enum PixelStoreParam : uint
    {
        UnpackAlignment = 3317,
        PackAlignment = 3333
    }

    public enum PixelStoreValue : uint
    {
        ByteAlignment = 1,
        EvenNumberedAlignment = 2,
        WordAlignment = 4,
        DWordAlignment = 8
    }

    public enum Comparison
    {
        Always = 519,
        Never = 512,
        Less = 513,
        Equal = 514,
        LessOrEqual = 515,
        Greater = 516,
        NotEqual = 517,
        GreaterOrEqual = 518
    }

    public enum BlendFactor : uint
    {
        Zero = 0,
        One = 1,
        SrcColor = 768,
        OneMinusSrcColor = 769,
        SrcAlpha = 770,
        OneMinusSrcAlpha = 771,
        DstAlpha = 772,
        OneMinusDstAlpha = 773,
        DstColor = 774,
        OneMinusDstColor = 775,
        SrcAlphaSaturate = 776
    }

    public enum HintTarget : uint
    {
        Fog = 3156,
        LineSmooth = 3154,
        PerspectiveCorrection = 3152,
        PointSmooth = 3153
        //  PolygonSmooth
    }

    public enum HintMode : uint
    {
        DontCare = 4354,
        Fastest = 4354,
        Nicest = 4353
    }

    public enum MatrixMode : uint
    {
        ModelView = 5888,
        Projection = 5889,
        Texture = 5890
    }

    public enum ClientStateArray : uint
    {
        Color = 32886,
        Normal = 32885,
        TextureCoord = 32888,
        Vertex = 32884
        //EdgeFlagArray,
        //IndexArray,
    }

    public enum TextureUnit : uint
    {
        Texture0 = 33984,
        Texture1 = 33985
        #region not supported
        //Texture2 = 33986,
        //Texture3 = 33987,
        //Texture4 = 33988,
        //Texture5 = 33989,
        //Texture6 = 33990,
        //Texture7 = 33991,
        //Texture8 = 33992,
        //Texture9 = 33993,
        //Texture10 = 33994,
        //Texture11 = 33995,
        //Texture12 = 33996,
        //Texture13 = 33997,
        //Texture14 = 33998,
        //Texture15 = 33999,
        //Texture16 = 34000,
        //Texture17 = 34001,
        //Texture18 = 34002,
        //Texture19 = 34003,
        //Texture20 = 34004,
        //Texture21 = 34005,
        //Texture22 = 34006,
        //Texture23 = 34007,
        //Texture24 = 34008,
        //Texture25 = 34009,
        //Texture26 = 34010,
        //Texture27 = 34011,
        //Texture28 = 34012,
        //Texture29 = 34013,
        //Texture30 = 34014,
        //Texture31 = 34015
        #endregion
    }

    [Flags]
    public enum ColorBufferBit
    {
        Color = 16384,
        Depth = 256,
        Stencil = 1024
        //Accumulation,
    }

    public enum PrimitiveType
    {
        Points = 0,
        Lines = 1,
        LineStrip = 3,
        LineLoop = 2,
        Triangles = 4,
        TriangleStrip = 5,
        TriangleFan = 6
        //Quads,
        //QuadStrip,
        //Polygon
    }

    public enum glValueType : uint
    {
        Unknown = 0,
        Byte = 5120,
        UnsignedByte = 5121,
        Short = 5122,
        UnsignedShort = 5123,
        Float = 5126,

        /// <summary>
        /// Is equal to Integer
        /// </summary>
        Fixed = 5132,

        UnsignedShort4444 = 32819,
        UnsignedShort5551 = 32820,
        UnsignedShort565 = 33635
    }

    public enum TextureFilter : uint
    {
        //GenerateMipMap = 33169,
        Minifying = 10241,
        Magnification = 10240,
        WrapS = 10242,
        WrapT = 10243
    }

    public enum TextureTarget : uint
    {
        Texture2D = 3553,
        TextureEnv = 8960
    }

    public enum GlesPixelFormat : uint
    {
        Unknown = 0,
        RGB = 6407,
        RGBA = 6408,
        Alpha = 6406,
        Luminance = 6409,
        LuminanceAlpha = 6410,
    }

    public enum TextureFormat
    {
        Automatic,
        RGB555,
        RGB565,
        RGB24,
        RGBA5551,
        RGBA4444,
        RGBA8888,

        /// <summary>
        /// Uses neither color nor luminance. Fast to render.
        /// </summary>
        Alpha,
        Luminance,
        LuminanceAlpha,

        /// <summary>
        /// Hi resolution alpha, but with performance penalty compared with Alpha.
        /// </summary>
        HiResAlpha,

    }

    public enum ParameterName : uint
    {
        AlphaBits = 3413,
        AlphaScale = 3356,
        AlphaTest = 3008,
        AlphaTestFunc = 3009,
        AlphaTestRef = 3010,
        Blend = 3042,
        BlendSrc = 3040,
        BlendDst = 3041,
        MaxTextureUnits = 34018,
        StencilBits = 3415,
        MaxClipPlanes = 3378,
        MaxTextureSize = 3379,

        //... to be extended.
    }

    public enum TextureParam
    {
        Repeat = 10497,
        ClampToEdge = 33071,
        Nearest = 9728,
        Linear = 9729,
        NearestMipmapNearest = 9984,
        LinearMipmapNearest = 9985,
        NearestMipmapLinear = 9986,
        LinearMipmapLinear = 9987,
        MaxModelViewStackDepth = 3382,
        MaxProjectionStackDepth = 3384,
        MaxTextureStackDepth = 3385,
        MaxViewPortDims = 3386,
        MaxTextureUnits = 34018
    }


    public enum CullFaceMode : uint
    {
        Front = 1028,
        Back = 1029,
        FrontAndBack = 1032
    }

    public enum FogParam : uint
    {
        Density = 2914,
        Start = 2915,
        End = 2916,
        Mode = 2917,
        Color = 2918
    }


    public enum FogMode : uint
    {
        Exp = 2048,
        Exp2 = 2049,
        Nearest = 9728,
        Linear = 9729
    }



    //GLAPI void APIENTRY glDrawTexsOES (GLshort x, GLshort y, GLshort z, GLshort width, GLshort height);
    //GLAPI void APIENTRY glDrawTexiOES (GLint x, GLint y, GLint z, GLint width, GLint height);
    //GLAPI void APIENTRY glDrawTexfOES (GLfloat x, GLfloat y, GLfloat z, GLfloat width, GLfloat height);
    //GLAPI void APIENTRY glDrawTexxOES (GLfixed x, GLfixed y, GLfixed z, GLfixed width, GLfixed height);
}

