﻿using System;

using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Silvermoon.Debug
{
    public static class NativeMemory
    {
        public struct MemoryStatus
        {
            internal uint dwLength;
            public int MemoryLoad;
            public int TotalPhysical;
            public int AvailablePhysical;
            public int TotalPageFile;
            public int AvailablePageFile;
            public int TotalVirtual;
            public int AvailableVirtual;

            public string AvailableAsString
            {
                get
                {
                    return FormatSize(AvailablePhysical);
                }
            }
        }

        public static string FormatSize(int size)
        {
            int low = size % 1000;
            int high = (size / 1000) % 1000;
            int ultra = (size / 1000000) % 1000;

            if (high == 0 && ultra == 0) return string.Format("{0} Byte", low);
            if (ultra == 0) return string.Format("{0:d}.{1:D3} Byte", high, low);
            return string.Format("{0:d}.{1:D3}.{2:D3} Byte", ultra, high, low);
        }

        [DllImport("coredll", SetLastError = false)]
        private static extern void GlobalMemoryStatus(out MemoryStatus status);

        public static MemoryStatus GetMemoryStatus()
        {
            MemoryStatus status;
            GlobalMemoryStatus(out status);
            return status;
        }
    }
}
