﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Silvermoon.Windows.Styles;
using Silvermoon.Shapes;
using Silvermoon.Windows;
using Silvermoon.OpenGL;
using Silvermoon.Controls;
using System.Drawing;

namespace Silvermoon.Debug
{
    public static class StylePool
    {
        public static readonly Style Window = new Style
        {
            Background = new GradientStopShape
            {                 
                End = 2,
                GradientStops =
                    new GradientStop[]
                {
                      new GradientStop(0,255,0,0,0),
                      new GradientStop(1,255,0,0,100),
                      new GradientStop(2,255,0,0,0)
                }
            }
        };

        public static readonly Style ContactWindow = new Style
        {
            Background = new GradientStopShape
            {
                 Orientation= Orientation.Landscape,
                End = 2,
                GradientStops =
                    new GradientStop[]
                {
                      new GradientStop(0,255,0,0,0),
                      new GradientStop(1,255,0,0,100),
                      new GradientStop(2,255,0,0,0)
                }
            }
        };


        public static readonly Style Login = new Style
        {
            Background = new GradientStopShape
           {
               GradientStops = new GradientStop[] { 
                    new GradientStop(0, 255,0,0,0),
                    new GradientStop(1, 255,0,100,0),
                    new GradientStop(2, 255,0,0,0)
                },
               Start = 0,
               End = 3
           }
        };

        public static readonly LabelStyle SmallDebugLabel = new LabelStyle
        {
            TextColor = PhoneColors.Accent,
            FontScale = 0.8f,
            LineAlignment = Alignment.Near,
            Alignment = Alignment.Far,
            Margin = Margin.Zero
        };

        public static readonly LabelStyle LargeDebugLabel = new LabelStyle
        {
            Font = FontSprite.FromData(GlFontFamily.GenericSansSerif, 16, FontStyle.Regular),
            LineAlignment = Alignment.Far,
            Alignment = Alignment.Far,
            Margin = Margin.Zero
        };


    }
}
