﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Silvermoon.Animations
{
    /// <summary>
    /// Defines the basic functionality of an easing function.
    /// </summary>
    public interface IEasingFunction
    {
        /// <summary>
        /// Transforms normalized time to control the pace of an animation.
        /// </summary>
        /// <param name="normalizedTime">The normalized time which starts with 0.0f and ends with 1.0f.</param>
        /// <returns>Transformed progress starting with 0.0f and ending with 1.0f but other values outside this range is allowed between.</returns>
        float Ease(float normalizedTime);
    }
}
