﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Silvermoon.ComponentModel
{
    public enum  ItemListChangedType
    {
        // Summary:
        //     Much of the list has changed. Any listening controls should refresh all their
        //     data from the list.
        Reset = 0,
        //
        // Summary:
        //     An item added to the list. System.ComponentModel.ListChangedEventArgs.NewIndex
        //     contains the index of the item that was added.
        ItemAdded = 1,
        //
        // Summary:
        //     An item deleted from the list. System.ComponentModel.ListChangedEventArgs.NewIndex
        //     contains the index of the item that was deleted.
        ItemDeleted = 2,
        //
        // Summary:
        //     An item moved within the list. System.ComponentModel.ListChangedEventArgs.OldIndex
        //     contains the previous index for the item, whereas System.ComponentModel.ListChangedEventArgs.NewIndex
        //     contains the new index for the item.
        ItemMoved = 3,
        //
        // Summary:
        //     An item changed in the list. System.ComponentModel.ListChangedEventArgs.NewIndex
        //     contains the index of the item that was changed.
        ItemChanged = 4,
    }
}
