﻿using System;

using System.Collections.Generic;
using System.Text;
using Silvermoon.OpenGL;
using Silvermoon.UI;
using Silvermoon.Shapes;
using Silvermoon.Utils;
using Silvermoon.Windows;

namespace Silvermoon.Controls.Beta
{
    public class ListBoxTextItem : ListBoxItem
    {

        static ListBoxTextItem()
        {
            VisualStateManager manager = new VisualStateManager(
                new VisualState(VState.Normal, 500),
                new VisualState(VState.Pressed,
                    new ScaleTransition { Duration = 5, To = new ScaleTransform(0.92f, 0.92f, 1f) },
                    new FloatTransition { Property = YRotationProperty, To = -2f, Duration = 5 }
                 )
            );
            VisualStateManager.RegisterClassManager(typeof(ListBoxTextItem), manager);
        }


        public ListBoxTextItem()
            : base()
        {
            label.Alignment = Alignment.Near;
        }

        public ListBoxTextItem(string text)
            : this()
        {
            Text = text;
        }

        public ListBoxTextItem(string text, FontSprite font)
            : this()
        {
            Text = text;
            Font = font;
        }

    }

}
