﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Silvermoon.Controls
{
    [Flags]
    public enum ControlFlags
    {
        None = 0,
        Visible = 1,
        Enabled = 2,
        Focused = 4,
        CanFocus = 8,
        HitTestVisible = 16,


        /// <summary>
        /// Specifies whether the control will receive Scoll events.
        /// </summary>
        CanPan = 32,

        EnableLongPress = 64,

        /// <summary>
        /// Specifies whether the control has a background.
        /// </summary>
        Background = 128,

        /// <summary>
        /// Specifies if a ContextMenu is attached.
        /// </summary>
        ContextMenu = 512,

        Disposed = 1024,
        
        AlwaysRaiseTapEvent=2048,
        Command = 4096,
        CommandEvent = 8192,
        Internal1 = 0x4000,
        Internal2 = 0x8000,
        Disposing = 0x10000

    }
}
