﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Silvermoon.Controls
{
    [Flags]
    public enum FormTransitionMode : uint
    {
        None = 0,
        MoveSrcToRight = 1,
        MoveSrcToLeft = 2,
        MoveSrcDown = 4,
        MoveSrcUp = 8,

        MoveDstToLeft = 0x10,
        MoveDstToRight = 0x20,
        MoveDstDown = 0x40,
        MoveDstUp = 0x80,

        FadeSrc = 0x100,
        FadeDst = 0x200,

        ZoomIn = 0x400,
        ZoomOut = 0x800,
        Negative = 0x8000,

        SwipeToLeft = MoveSrcToRight | MoveDstToRight | FadeSrc,
        SwipeToRight = MoveSrcToLeft | MoveDstToLeft | FadeDst,
        ShiftToLeft = MoveDstToRight | FadeDst,
        ShiftToRight = MoveSrcToLeft | FadeDst,
        ShiftUp = MoveDstDown | FadeDst,
        ShiftDown = MoveDstDown | FadeDst,
        Fade = FadeSrc | FadeDst
    }
}
