﻿using System;

using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Silvermoon.Controls
{
    public class HandledEventArgs : EventArgs
    {
        /// <summary>
        /// Set to true to notify that the event is handled.
        /// </summary>
        public bool Handled { get; set; }
    }

    /// <summary>
    /// EventArgs that provide information for Cancel and Handled.
    /// </summary>
    public class CancelEventArgs : HandledEventArgs
    {
        /// <summary>
        /// Set to true to cancel bubbling the event to parent controls.
        /// </summary>
        public bool Cancel { get; set; }

        internal void ClearFlags()
        {
            Cancel = Handled = false;
        }
    }
}
