﻿using System;

using System.Collections.Generic;
using System.Text;
using Silvermoon.Controls.Base;

namespace Silvermoon.Controls.Interfaces
{
    /// <summary>
    /// Decorates a control to be a Decorator.
    /// A Decorator is a control that embedds another control and adding some custom shapes.
    /// A control that has IDecorator implemented uses the Margin property of the embedded control to adjust the boundaries.
    /// </summary>
    public interface IDecorator
    {
        /// <summary>
        /// Gets or sets the control to be decorated.
        /// </summary>
        Control Control { get; set; }
    }
}
