﻿using System;

using System.Collections.Generic;
using System.Text;
using Silvermoon.Controls.Base;

namespace Silvermoon.Controls.Interfaces
{
    /// <summary>
    /// Used for <see cref="T:PageContainer"/>s to specify hierarchical browsing.
    /// </summary>
    public interface IPage
    {
        /// <summary>
        /// The button to 
        /// </summary>
        ButtonBase Button { get; }

        /// <summary>
        /// The title to display.
        /// </summary>
        string Title { get; }

        /// <summary>
        /// The parent Page for browsing, otherwise null.
        /// </summary>
        IPage ParentPage { get; }

        /// <summary>
        /// The control to be displayed.
        /// </summary>
        Control Control { get; }
    }
}
