﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Silvermoon.Controls.Interfaces
{
    /// <summary>
    /// Describes the requirements for a toolbar.
    /// </summary>
    public interface IToolbar
    {
        /// <summary>
        /// Gets or sets the window that holds the toolbar.
        /// </summary>
        Window Window { get; set; }

        /// <summary>
        /// Used for toolbar transitioning within a range of -1f and 1f where 0f is the default value.
        /// </summary>
        float ButtonVisibility { get; set; }

        /// <summary>
        /// Gets the minimum height or width (depending on the screen's orientation) for the toolbar. This
        /// is usually the height or width of the toolbar in collapsed state (without showing optional menu).
        /// </summary>
        int CollapsedSize { get; }

        /// <summary>
        /// Gets  the width or height (depending on screen's orientation) of the toolbar that is currently available.
        /// </summary>
        int CurrentSize { get; }

    }
}
