﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Silvermoon.UI;
using Silvermoon.Windows;
using Silvermoon.Animations;
using System.Drawing;

namespace Silvermoon.Controls
{
    public class DropDownBoxManagers
    {
        public static readonly VisualStateManager Default = new VisualStateManager(
            new VisualStateGroup(
                new VisualState(VState.Enabled, 250),
                new VisualState(VState.Disabled, new IntTransition { Property = ChromeControl.BackgroundOpacityProperty, To = 0, Duration = 250 },
                    new ColorTransition { Property = Control.TextColorProperty, To = PhoneColors.Text, Duration = 5 })
                ),
                 new VisualStateGroup(
                     new VisualState("Expanded",
                         new ColorTransition(DropDownBox.ColorProperty, 300, null, PhoneColors.White) { Tracking = TrackMode.Keep },
                         new IntTransition(DropDownBox.ChromeOpacityProperty, 1, null, 255),
                         new FloatTransition(DropDownBox.ExpansionProperty, 300, null, 1f, PowerEase.Out) { Tracking = TrackMode.Keep }),
                     new VisualState("Collapsed",
                         new ColorTransition(DropDownBox.ColorProperty, 300, null, PhoneColors.Light) { Tracking = TrackMode.Keep },
                         new FloatTransition(DropDownBox.ExpansionProperty, 300, null, 0f, PowerEase.Out) { Tracking = TrackMode.Keep })
               )
         );

    }
}
