﻿using System;

using System.Collections.Generic;
using System.Text;
using Silvermoon.Controls.Base;

namespace Silvermoon.Controls
{
    /// <summary>
    /// Specifies the requirements for a node of any derived <see cref="NavigationBase"/>, e.g. <see cref="Pivot"/>.
    /// </summary>
    public interface INavigationNode 
    {
        /// <summary>
        /// Gets the previous node, otherwise null.
        /// </summary>
        INavigationNode Previous { get; }

        /// <summary>
        /// Gets the next node, otherwise null.
        /// </summary>
        INavigationNode Next { get; }
    }
}
