﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Silvermoon.Controls
{
    [Flags]
    public enum PivotMode : short
    {
        None = 0,

        /// <summary>
        /// The bigger the distance from the centered node, the more transparent the tile becomes.
        /// </summary>
        Transparency = 1,

        /// <summary>
        /// The bigger the distance from the centered node, the smaller the tile becomes.
        /// </summary>
        Scale = 2,

        /// <summary>
        /// Each tile has its own size rather than one global size. This does not work together with Scale.
        /// </summary>
        Tabbed = 4
    }
}
