﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Silvermoon.Controls.Textboxes
{
    /// <summary>
    /// Specifies the target to drag.
    /// </summary>
    public enum DragTarget : short
    {

        /// <summary>
        /// No target is dragged, which means that the textbox is scrolled.
        /// </summary>
        None,

        /// <summary>
        /// Drag the cursor.
        /// </summary>
        Caret,

        /// <summary>
        /// Drag the start of the selection.
        /// </summary>
        SelectionStart,

        /// <summary>
        /// Drag the end of the selection.
        /// </summary>
        SelectionEnd
    }

}
