﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Silvermoon.Navigation
{
    /// <summary>
    /// Describes the type of navigation from one page to another.
    /// </summary>
    public enum PageTransitionMode
    {
        /// <summary>
        /// The opened page first closes and then the target page opens.
        /// </summary>
        HideThenShow,

        /// <summary>
        /// The opened page closes at the same time the target page opens while the opening page is topmost.
        /// </summary>
        ShowAndHide,

        /// <summary>
        /// The opened page closes at the same time the target page opens while the closing page is topmost. 
        /// </summary>
        HideAndShow,

        /// <summary>
        /// The page to navigate to opens over the current page.
        /// </summary>
        Show,

        /// <summary>
        /// The current page hides and the page to navigate to appears.
        /// </summary>
        Hide
    }
}
