﻿using System;

using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Silvermoon.OpenGL.Native.Vectors
{
    [StructLayout(LayoutKind.Sequential)]
    public struct Vector2s
    {
        public short X;
        public short Y;

        public Vector2s(short x, short y)
        {
            X = x;
            Y = y;
        }

        public void SetValues(int x, int y)
        {
            this.X = (short)x;
            this.Y = (short)y;
        }

        internal void Set(int x, int y)
        {
            this.X = (short)x;
            this.Y = (short)y;
        }

        public override string ToString()
        {
            return string.Format("{0}, {1}", X, Y);
        }

    }

    [StructLayout(LayoutKind.Sequential)]
    public struct Vector3s
    {
        public short X;
        public short Y;
        public short Z;

        public Vector3s(short x, short y, short z)
        {
            X = x;
            Y = y;
            Z = z;
        }
    }
}
