﻿using System;

using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Silvermoon.Shapes
{
    public class BorderFillShape : MultiShape
    {
        private BorderShape borderShape;
        private RectangleShape colorShape;

        public BorderFillShape()
            : base()
        {
            borderShape = new BorderShape();
            colorShape = new RectangleShape();
            Shapes.Add(colorShape);
            Shapes.Add(borderShape);
        }

        public override Color Color
        {
            get
            {
                return colorShape.Color;
            }
            set
            {
                colorShape.Color = value;
                Invalidate();
            }
        }

        public Color BorderColor
        {
            get { return borderShape.Color; }
            set
            {
                borderShape.Color = value;
                Invalidate();
            }
        }

        public int BorderSize
        {
            get { return borderShape.BorderSize; }
            set
            {
                borderShape.BorderSize = value;
                Invalidate();
            }
        }

        public BorderEdge Edges
        {
            get { return borderShape.Edges; }
            set
            {
                borderShape.Edges = value;
                Invalidate();
            }
        }
    }
}
