﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Silvermoon.Shapes
{
    /// <summary>
    /// Styles for rendering a textured rectangle.
    /// </summary>
    public enum RenderStyle
    {
        /// <summary>
        /// Maps the texture 1:1 on the shape and colorizes the shape with a solid color.
        /// </summary>
        Simple,

            /// <summary>
        /// Maps the texture edged and applies a color gradient from top to bottom that gives the rectangle a plastic effect.
        /// </summary>
        Plastic,

        /// <summary>
        /// Maps the texture edged and applies a color gradient from top to bottom that gives the rectangle a metallic chrome effect.
        /// </summary>
        Metalic,

        /// <summary>
        /// Maps the texture edged which means that if the texture is smaller than the shape, the texure is split into 4 edges where each edge is mapped 1:1 at each edge at the
        /// upper-left, upper-right, lower-left and lower-right edge, while the gap is filled with the color of the texture between.
        /// </summary>
        Edged,

        /// <summary>
        /// Maps the texture edged and applies a color gradient from top to bottom that gives the rectangle a sleight chrome effect.
        /// </summary>       
        FlatChrome,

        /// <summary>
        /// Maps the texture 1:1 on the shape and applies a color gradient from top to bottom.
        /// </summary>
        Gradiented
    }
}
