﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Silvermoon.UI
{
    /// <summary>
    /// Specifies how <see cref="VisualStateManager"/> behaves if a Transition is removed from a property.
    /// </summary>
    public enum TrackMode : short
    {
        // Keeps the original value of the property if no other animation is applied on and reverses to that value 
        // when either <see cref="VisualStateManager"/> removes the animation, or  PropertyAccessor.EndAnimation is called explicitely.
        // This is the default mode.
        Reversible,

        // Keeps the target value as original value.
        Keep
    }
}
