﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Silvermoon.Controls;
using Silvermoon.Shapes;

namespace Silvermoon.Windows.Styles
{
    public class WindowStyle : FormStyle
    {
        public Color ToolbarColor;
        public Color ToolbarTextColor;
        public Shape ToolbarBackground;
        public int? ToolbarOpacity;

        public override void Apply(Silvermoon.Controls.Control c)
        {
            base.Apply(c);
            Window w = c as Window;
            if (w != null)
            {
                if (ToolbarBackground != null) w.ToolbarBackground = ToolbarBackground;
                if (!ToolbarColor.IsEmpty) w.ToolbarColor = ToolbarColor;
                if (!ToolbarTextColor.IsEmpty) w.ToolbarTextColor = ToolbarTextColor;
                if (ToolbarOpacity.HasValue) w.ToolbarOpacity = ToolbarOpacity.Value;
            }
        }
    }
}
